// #############################################################################
// *****************************************************************************
//                  Copyright ( c ) 2008, Advantech Automation Corp.
//      THIS IS AN UNPUBLISHED WORK CONTAINING CONFIDENTIAL AND PROPRIETARY
//               INFORMATION WHICH IS THE PROPERTY OF ADVANTECH AUTOMATION CORP.
//
//    ANY DISCLOSURE, USE, OR REPRODUCTION, WITHOUT WRITTEN AUTHORIZATION FROM
//               ADVANTECH AUTOMATION CORP., IS STRICTLY PROHIBITED.
// *****************************************************************************
// #############################################################################
/***
 * File:      getstat.c
 * Created:      2008-10-20
 * Revision:       1.00 
 *
 * Description:      Getstat.c implements showCANStat(fd) 
 */
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <devctl.h>
#include <fcntl.h>
#include "advcan.h"

#define STDDEV "advcan0"
void  showCANStat(int fd);

void showCANStat(int fd)
{
   CanStatusPar_t status;
    ioctl(fd, CAN_IOCTL_STATUS, &status);
    printf("\nDevice stat:\n \
    baud=%d\n \
    status=%d\n \
    error_warning_limit=%2d\n \
    rx_errors=%2d\n \
    tx_errors=%2d\n \
    error_code=%2d\n \
    tx_buffer_size:%3d/used%3d\n \
    rx_buffer_size:%3d/used%3d\n",
 
      status.baud,
      status.status,
      status.error_warning_limit,
      status.rx_errors,
      status.tx_errors,
      status.error_code,
      status.tx_buffer_size,
      status.tx_buffer_used,
      status.rx_buffer_size,
      status.rx_buffer_used);
}

int main(int argc,char **argv)
{
   int can_fd;
   char device[40];
   int newbaud = 250;

   printf("usage: %s [dev] \n", argv[0]);
   printf("e.g.:\n");
   printf("./getstat advcan0\n\n");


   if(argc > 1) 
   {
      sprintf(device, "/dev/%s", argv[1]);
   }
   else 
   {
      sprintf(device, "/dev/%s", STDDEV);
   }
   printf("using CAN device %s\n", device);
    
   if(( can_fd = open(device, O_RDWR )) < 0 ) 
   {
      printf("Error opening CAN device %s\n", device);
      exit(1);
   }
   showCANStat(can_fd);
}
