// #############################################################################
// *****************************************************************************
//                  Copyright ( c ) 2008, Advantech Automation Corp.
//      THIS IS AN UNPUBLISHED WORK CONTAINING CONFIDENTIAL AND PROPRIETARY
//               INFORMATION WHICH IS THE PROPERTY OF ADVANTECH AUTOMATION CORP.
//
//    ANY DISCLOSURE, USE, OR REPRODUCTION, WITHOUT WRITTEN AUTHORIZATION FROM
//               ADVANTECH AUTOMATION CORP., IS STRICTLY PROHIBITED.
// *****************************************************************************
// #############################################################################
/***
 * File:              receive-select.c
 * Created:           2008-10-20
 * Revision:          1.00 
 *
 * Description:       Receive example useing select.
 */
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <fcntl.h>
#include <unistd.h>
#include "advcan.h"

#define STDDEV "advcan0"
#define  MAX 5

int main(int argc,char **argv)
{
   int can_fd;        /* CAN file descriptor */
   int got;
   canmsg_t rx[MAX];
   char device[40];   /* string to hold the CAN device Name */
   fd_set rfds;       /* file descriptors for select() */
   fd_set wfds;       /* file descriptors for select() */
   int count = 0;
   int i;

   printf("usage: %s <dev>]\n", argv[0]);
   printf("   e.g.:\n");
   printf("   %s advcan0\n", argv[0]);
   printf("   wait for CAN messages using select()\n");
   if ( argc > 1)
   {
      sprintf(device, "/dev/%s", argv[1]);
   }
   else
   {
      sprintf(device, "/dev/%s", STDDEV);
   }
   printf("using CAN device %s, ", device);
    
   if(( can_fd = open(device, O_RDWR )) < 0 ) 
   {
      fprintf(stderr,"Error opening CAN device %s\n", device);
      exit(1);
   }
   printf("got can_fd  %d\n", can_fd);
   while(1) 
   {
      FD_ZERO(&rfds);
      FD_SET(can_fd, &rfds);     /* watch on fd for CAN */
      FD_SET(0, &rfds);          /* watch on fd for stdin */
      if( select(can_fd+1, &rfds,0, NULL,     NULL  ) > 0 )
      {   
         if( FD_ISSET(can_fd, &rfds) ) 
         {
            got = read(can_fd, rx, sizeof( canmsg_t )*MAX);
            if( got > 0) 
            {
               count+= got/sizeof( canmsg_t );
               printf("get message\n");
               printf("count: %d\n",count);
               for(i=0;i< got/sizeof( canmsg_t );i++)
               {
         printf ("msg %d ,flag %d: ", rx[i].id,rx[i].flags);
         printf("%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t\n",
                 rx[i].data[0],
                 rx[i].data[1],
                 rx[i].data[2],
                 rx[i].data[3],
                 rx[i].data[4],
                 rx[i].data[5],
                 rx[i].data[6],
                 rx[i].data[7] ); 
               }
            }
         }
         if( FD_ISSET(0, &rfds) ) 
         {
            int c, i;
            /* it was the stdio terminal fd */
            i = read(0 , &c, 1);
            printf(" key = %x\n", c);
         } 
      }
   }
   close(can_fd);
   return 0;
}
