// #############################################################################
// *****************************************************************************
//                  Copyright ( c ) 2009, Advantech Automation Corp.
//      THIS IS AN UNPUBLISHED WORK CONTAINING CONFIDENTIAL AND PROPRIETARY
//               INFORMATION WHICH IS THE PROPERTY OF ADVANTECH AUTOMATION CORP.
//
//    ANY DISCLOSURE, USE, OR REPRODUCTION, WITHOUT WRITTEN AUTHORIZATION FROM
//               ADVANTECH AUTOMATION CORP., IS STRICTLY PROHIBITED.
// *****************************************************************************
// #############################################################################
/***
 * File:         receive.c
 * Created:      2009-10-20
 * Revision:     1.00 
 *
 * Description:      This example puts all received datas and print the message
 *         you can compare them with the transmited datas to test whether they are right
 */
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <devctl.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include "advcan.h"

#define STDDEV "advcan0"
#define RXBUFFERSIZE 100
#define MAX 300

int set_bitrate(
   int can_fd, /* device descriptor */
   int baud    /* bit rate */
   )
{
   Config_par_t  cfg;
   volatile Command_par_t cmd;

   cmd.cmd = CMD_STOP;
   ioctl(can_fd, CAN_IOCTL_COMMAND, &cmd);

   cfg.target = CONF_TIMING; 
   cfg.val1   = baud;
   ioctl(can_fd, CAN_IOCTL_CONFIG, &cfg);

   cmd.cmd = CMD_START;
   ioctl(can_fd, CAN_IOCTL_COMMAND, &cmd);
   return 0;
}

/***********************************************************************
*
* main 
*
*/
int main(int argc,char **argv)
{
   int fd;
   int got;
   int i;
   int c,count = 0;
   char *pname;
   extern char *optarg;
   extern int optind;
   int readcount;

   canmsg_t rx[MAX];
   char device[50];

   printf("usage: %s [dev] \n", argv[0]);
   if(argc > 1) 
   {
      sprintf(device, "/dev/%s", argv[1]);
   }
   else 
   {
   sprintf(device, "/dev/%s", STDDEV);
   }
   
   fd = open(device, O_RDONLY);
   if( fd < 0 ) 
   {
      fprintf(stderr,"Error opening CAN device %s\n", device);
      perror("open");
      exit(1);
   }
   printf("using CAN device %s\n", device);
   
   //set baud rate to 1000K,defaulet is 125K
   //set_bitrate(fd, 1000);
   
   while( 1 )
   { 
      got=read(fd, rx, MAX*sizeof(canmsg_t));
      if (got > 0)
      {
         readcount = got/ sizeof(canmsg_t);
         count+=readcount;
          
         for(i=0;i<readcount;i++)
         {
            printf ("msg %d ,flag %d:  ", rx[i].id,rx[i].flags);
            printf("%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t\n",
                 rx[i].data[0],
                 rx[i].data[1],
                 rx[i].data[2],
                 rx[i].data[3],
                 rx[i].data[4],
                 rx[i].data[5],
                 rx[i].data[6],
                 rx[i].data[7] ); 
         }
      } 
   }
   printf("Total receive message count: %d\n",count);
   close(fd);
   return 0;
}
