// #############################################################################
// *****************************************************************************
//                  Copyright ( c ) 2008, Advantech Automation Corp.
//      THIS IS AN UNPUBLISHED WORK CONTAINING CONFIDENTIAL AND PROPRIETARY
//               INFORMATION WHICH IS THE PROPERTY OF ADVANTECH AUTOMATION CORP.
//
//    ANY DISCLOSURE, USE, OR REPRODUCTION, WITHOUT WRITTEN AUTHORIZATION FROM
//               ADVANTECH AUTOMATION CORP., IS STRICTLY PROHIBITED.
// *****************************************************************************
// #############################################################################
/***
 * File:              transmit-select.c
 * Created:           2008-10-20
 * Revision:          1.00 
 *
 * Description:       Transmit example using select.
 */
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <sys/time.h>
#include "advcan.h"
#include <time.h>
#define STDDEV "advcan1"
#define MAX 10

struct timespec begin,end;
int main(int argc,char **argv)
{
   int can_fd;   /* CAN file descriptor */
   int got,i,j;
   canmsg_t rx;   /* buffer for received message */
   canmsg_t tx[MAX];   /* buffer for transmit messsage */
   char device[40];   /* string to hold the CAN device Name */
   fd_set rfds;   /* file descriptors for select() */
   fd_set wfds;   /* file descriptors for select() */
   long long count;

   if(argc == 2) 
   {
      sprintf(device, "/dev/%s", argv[1]);
   }
   else 
   {
      sprintf(device, "/dev/%s", STDDEV);
   }
   printf("using CAN device %s, ", device);
    
   if(( can_fd = open(device, O_RDWR )) < 0 ) 
   {
      printf("Error opening CAN device %s\n", device);
      exit(1);
   }
   printf("got can_fd  %d\n", can_fd);

   /* prepare the fixed part of transmit message */
    for(i=0;i<MAX;i++)
   {
      for ( j = 0; j<8;j++)
      {
         tx[i].data[j] =i+ j;
      }
      tx[i].flags = 0;  
      tx[i].length = 8 ;
      tx[i].id=500 + i;
 
   }
   count = 0;
   for(i=0;i<MAX;i++)
   {
      clock_gettime(CLOCK_REALTIME,&begin);
      FD_ZERO(&rfds);
      FD_ZERO(&wfds);
      FD_SET(can_fd, &rfds);     /* watch on fd for CAN */
      FD_SET(can_fd, &wfds);     /* watch on fd for CAN */
      FD_SET(0, &rfds);         /* watch on fd for stdin */
      if( select( FD_SETSIZE, &rfds, &wfds, NULL,     NULL ) > 0 )
      {   
         if( FD_ISSET(can_fd, &wfds) ) 
         {  
           got= write(can_fd, &tx[i], sizeof( canmsg_t)*1);
           if(got>0)
           {
                count += got/sizeof( canmsg_t);
                printf("Write down %d\n", count);
           }
	   count = count % MAX;
           usleep(1);
         }

         if( FD_ISSET(can_fd, &rfds) ) 
         {
            got = read(can_fd, &rx, sizeof( canmsg_t));
            if (got)
            {
               printf("Error Occur !\n");
            }
            if (rx.id == 0xFFFFFFFF) 
            {
               printf("Error 0x%x\n", rx.flags);
               if (rx.flags & MSG_BUSOFF) 
               {
                  printf(" - BUSOFF\n");
	    	   }
	    	   if (rx.flags & MSG_PASSIVE) 
               {
                  printf(" - ERROR PASSIVE\n");
               }
            }
         }
         if( FD_ISSET(0, &rfds) ) 
         {
            int c, i;
            /* it was the stdio terminal fd */
            i = read(0 , &c, 1);
            clock_gettime(CLOCK_REALTIME,&end);
            printf("total write %d messages",count);
            getchar();
         } 
      }
   }
   close(can_fd);
   return 0;
}
