// #############################################################################
// *****************************************************************************
//                  Copyright ( c ) 2009, Advantech Automation Corp.
//      THIS IS AN UNPUBLISHED WORK CONTAINING CONFIDENTIAL AND PROPRIETARY
//               INFORMATION WHICH IS THE PROPERTY OF ADVANTECH AUTOMATION CORP.
//
//    ANY DISCLOSURE, USE, OR REPRODUCTION, WITHOUT WRITTEN AUTHORIZATION FROM
//               ADVANTECH AUTOMATION CORP., IS STRICTLY PROHIBITED.
// *****************************************************************************
// #############################################################################
/***
 * File:         transmit.c
 * Created:      2009-10-20
 * Revision:     1.00 
 *
 * Description:      Transmit example.
 *         Transmit sends a bunch of telegrams by filling them with       
 *         different CANids and data bytes. You may send more than one    
 *         telegram with write just by sending out an array of telegrams. 
 */
 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <devctl.h>
#include <fcntl.h>
#include <unistd.h>
#include "advcan.h"

#define STDDEV "advcan1"
#define MAX 10


int set_bitrate(
   int can_fd, /* device descriptor */
   int baud    /* bit rate */
   )
{
   Config_par_t  cfg;
   volatile Command_par_t cmd;

   cmd.cmd = CMD_STOP;
   ioctl(can_fd, CAN_IOCTL_COMMAND, &cmd);

   cfg.target = CONF_TIMING; 
   cfg.val1   = baud;
   ioctl(can_fd, CAN_IOCTL_CONFIG, &cfg);

   cmd.cmd = CMD_START;
   ioctl(can_fd, CAN_IOCTL_COMMAND, &cmd);
   return 0;
}

int main(int argc,char **argv)
{
   int fd;
   int i, sent, j, sendcount;
   canmsg_t tx[MAX];
   char device[40];
   if(argc == 2) 
   {
      sprintf(device, "/dev/%s", argv[1]);
   }
   else 
   {
      sprintf(device, "/dev/%s", STDDEV);
   }
   
   printf("using CAN device %s\n", device);
   
   if(( fd = open(device, O_RDWR )) < 0 ) 
   {
      fprintf(stderr,"Error opening CAN device %s\n", device);
      exit(1);
   }

   for(i=0;i<MAX;i++)
   {
      for ( j = 0; j<8;j++)
      {
         tx[i].data[j] =i+ j;
      }
      tx[i].flags = MSG_EXT;  
      tx[i].length = 8 ;
      tx[i].id=500 + i;
   }
   sendcount = 0;

	for(i=0;i<MAX;i++)
   {

      sent = write(fd,&tx[i],sizeof(canmsg_t));
      if (sent > 0)
      {
         sendcount = sendcount + (sent/sizeof( canmsg_t));
         printf("write down %d \n ",sent/sizeof(canmsg_t) );
      }
      sendcount = sendcount % MAX;
      usleep(1);
   }
   close(fd);
   return 0;
}

